-- Szukanie indeksu zadanego elementu
-- Adam Chrapkowski
-- www.algorytm.org
--
-- Compliant with Haskell 98 standard

import Maybe
import Text.Printf

myIndexOf :: (Ord t) => [t] -> t -> Int -> Maybe Int
myIndexOf []     k i = Nothing
myIndexOf (x:xs) k i
	| x == k    = Just i
	| otherwise = myIndexOf xs k (i + 1)

showIndexOf :: (Ord t) => [t] -> t -> String
showIndexOf xs x = case myIndexOf xs x 0 of
	Just i  -> "'x' found at index " ++ (printf "%d" i)
	Nothing -> "'x' has not been found"
